﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace ClickingGame
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        //atributy
        int score = 0;
        DispatcherTimer gameTimer = new DispatcherTimer();
        Random rand = new Random();
        int spawnRate = 20;
        int currentRate;

        public MainWindow()
        {
            InitializeComponent();

            gameTimer.Interval = TimeSpan.FromMilliseconds(20);
            gameTimer.Tick += GameLoop;
            gameTimer.Start();
            currentRate = spawnRate;
        }

        private byte RandomColor => (byte)rand.Next(0, 255); 

        private void GenerateCircle ()
        {
            int posX = rand.Next(15, 700);
            int posY = rand.Next(50, 350);

            Brush brush = new SolidColorBrush(Color.FromRgb(RandomColor, RandomColor, RandomColor));

            Ellipse circle = new Ellipse()
            {
                Height = 30,
                Width = 30,
                Stroke = Brushes.Black,
                StrokeThickness = 1,
                Fill = brush
            };
            Canvas.SetLeft(circle, posX);
            Canvas.SetTop(circle, posY);

            MyCanvas.Children.Add(circle);
        }

        float growRate = 0.6f;
        int health = 350;
        private void GameLoop (object sender, EventArgs e)
        {
        //    score++;
            lbScore.Content = "Score: " + score;
            currentRate -= 2;
            if (currentRate < 1)
            {
                GenerateCircle();
                currentRate = spawnRate;
            }

            //animace
            foreach (var x in MyCanvas.Children.OfType<Ellipse>().Reverse())
            {

                x.Height += growRate;
                x.Width += growRate;
                x.RenderTransformOrigin = new Point(0.5f, 0.5f);

                if (x.Width>70)
                {
                    MyCanvas.Children.Remove(x);
                    health -= 15;
                }
            }

            //vykresli panel zdravi
            if (health > 1)
                healthBar.Width = health;
            else
            {
                MessageBox.Show("GAME OVER"); this.Close();
            }
        }

        private void MyCanvas_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is Ellipse)
            {
                score++;
                Ellipse circle = (Ellipse)e.OriginalSource;
                MyCanvas.Children.Remove(circle);
            }
        }
    }
}
